searchData={"items":[{"type":"module","title":"ecron","doc":null,"ref":"ecron.html"},{"type":"function","title":"ecron.activate/1","doc":"Equivalent to activate(ecron_local, Name) .","ref":"ecron.html#activate/1"},{"type":"function","title":"ecron.activate/2","doc":"Activates a previously deactivated job. The job will resume from the current time. Parameters: Register - Process name where job is registered JobName - Name of job to activate Returns: ok | {error, not_found}","ref":"ecron.html#activate/2"},{"type":"function","title":"ecron.add/3","doc":"Equivalent to add(ecron_local, JobName, Spec, MFA) .","ref":"ecron.html#add/3"},{"type":"function","title":"ecron.add/4","doc":"Equivalent to add(Register, JobName, Spec, MFA, unlimited, unlimited, []) .","ref":"ecron.html#add/4"},{"type":"function","title":"ecron.add/6","doc":"Equivalent to add(ecron_local, name(), Spec, MFA, Start, End, []) .","ref":"ecron.html#add/6"},{"type":"function","title":"ecron.add/7","doc":"Adds a new crontab job with specified parameters. Jobs exceeding their limits are automatically removed. Parameters: Register - The process name where the job will be registered JobName - Unique identifier for the job. Returns {error, already_exist} if duplicate Spec - Crontab expression defining execution schedule MFA - {Module, Function, Args} to execute when triggered Start - Start time {Hour,Min,Sec} or unlimited for immediate start End - End time {Hour,Min,Sec} or unlimited for no end Opts - Options list: {singleton, boolean()} - If true (default), prevents concurrent execution {max_count, pos_integer() | unlimited} - Maximum executions allowed Returns: {ok, JobName} | {error, already_exist} | {error, parse_error(), term()}","ref":"ecron.html#add/7"},{"type":"function","title":"ecron.add_with_count/3","doc":"Equivalent to add_with_count(ecron_local, make_ref(), Spec, MFA, RunCount) .","ref":"ecron.html#add_with_count/3"},{"type":"function","title":"ecron.add_with_count/5","doc":"Equivalent to add(register(), make_ref(), Spec, MFA, unlimited, unlimited, [{max_count, RunCount}]) .","ref":"ecron.html#add_with_count/5"},{"type":"function","title":"ecron.add_with_time/5","doc":"Equivalent to add(ecron_local, name(), Spec, MFA, Start, End, []) .","ref":"ecron.html#add_with_time/5"},{"type":"function","title":"ecron.add_with_time/6","doc":"Equivalent to add(register(), name(), Spec, MFA, Start, End, []) .","ref":"ecron.html#add_with_time/6"},{"type":"function","title":"ecron.deactivate/1","doc":"Equivalent to deactivate(ecron_local, Name) .","ref":"ecron.html#deactivate/1"},{"type":"function","title":"ecron.deactivate/2","doc":"Deactivates an existing job temporarily. The job can be reactivated using activate/2. Parameters: Register - Process name where job is registered JobName - Name of job to deactivate Returns: ok | {error, not_found}","ref":"ecron.html#deactivate/2"},{"type":"function","title":"ecron.delete/1","doc":"Equivalent to delete(ecron_local, Name) .","ref":"ecron.html#delete/1"},{"type":"function","title":"ecron.delete/2","doc":"Deletes an existing job. If the job does not exist, it will be ignored. Parameters: Register - Process name where job is registered JobName - Name of job to delete Returns: ok","ref":"ecron.html#delete/2"},{"type":"function","title":"ecron.parse_spec/2","doc":"Parses a crontab specification and returns the next N trigger times. Useful for debugging and validating crontab expressions. Parameters: Spec - Crontab expression to parse Num - Number of future trigger times to calculate Returns: {ok, #{type =&gt; cron|every, crontab =&gt; parsed_spec, next =&gt; [rfc3339_string()]}} | {error, parse_error(), term()}","ref":"ecron.html#parse_spec/2"},{"type":"function","title":"ecron.reload/0","doc":"Reloads all tasks manually. Useful when system time has changed significantly. This will: Recalculate next execution times for all jobs Reset internal timers Apply to both local and global jobs Returns: ok","ref":"ecron.html#reload/0"},{"type":"function","title":"ecron.send_after/3","doc":"Creates a one-time timer that sends a message when the crontab spec is triggered. Parameters: Spec - Crontab expression defining when to trigger Dest - Destination pid() or registered name to receive message Message - Term to send when timer triggers Notes: Similar to erlang:send_after/3 but uses crontab format Dest pid must be local Maximum time value is 4294967295 milliseconds Timer auto-cancels if destination process dies Use erlang:cancel_timer/1 to cancel, not ecron:delete/1 Returns: {ok, reference()} | {error, parse_error(), term()}","ref":"ecron.html#send_after/3"},{"type":"function","title":"ecron.send_interval/3","doc":"Equivalent to send_interval(ecron_local, make_ref(), Spec, Pid, Message, unlimited, unlimited, []) .","ref":"ecron.html#send_interval/3"},{"type":"function","title":"ecron.send_interval/5","doc":"Equivalent to send_interval(ecron_local, name(), Spec, Pid, Message, unlimited, unlimited, []) .","ref":"ecron.html#send_interval/5"},{"type":"function","title":"ecron.send_interval/7","doc":"Equivalent to send_interval(register(), name(), Spec, self(), Message, Start, End, Option) .","ref":"ecron.html#send_interval/7"},{"type":"function","title":"ecron.send_interval/8","doc":"Sends a message to a process repeatedly based on a crontab schedule. Parameters: Register - Process name where job will be registered JobName - Unique identifier for the job Spec - Crontab expression defining execution schedule Pid - Destination process ID or registered name Message - Term to send on each trigger Start - Start time {Hour,Min,Sec} or unlimited End - End time {Hour,Min,Sec} or unlimited Option - Same options as add/7 Returns: Same as add/7","ref":"ecron.html#send_interval/8"},{"type":"function","title":"ecron.statistic/0","doc":"Retrieves statistics for both local and global registered jobs. Returns: List of statistics for all jobs in both local and global registries. Each statistic entry contains the same information as statistic/2.","ref":"ecron.html#statistic/0"},{"type":"function","title":"ecron.statistic/1","doc":"Retrieves statistics for local registered jobs. Returns: List of statistics for all jobs in local registries. Each statistic entry contains the same information as statistic/2.","ref":"ecron.html#statistic/1"},{"type":"function","title":"ecron.statistic/2","doc":"Retrieves statistics for a specific job. Parameters: Register - Process name where job is registered JobName - Name of job to get statistics for Returns: {ok, statistic()} | {error, not_found} Where statistic() contains: Job configuration Execution counts (success/failure) Latest results Run times Next scheduled runs","ref":"ecron.html#statistic/2"},{"type":"type","title":"ecron.crontab/0","doc":null,"ref":"ecron.html#t:crontab/0"},{"type":"type","title":"ecron.crontab_spec/0","doc":null,"ref":"ecron.html#t:crontab_spec/0"},{"type":"type","title":"ecron.ecron/0","doc":null,"ref":"ecron.html#t:ecron/0"},{"type":"type","title":"ecron.ecron_result/0","doc":null,"ref":"ecron.html#t:ecron_result/0"},{"type":"type","title":"ecron.end_at/0","doc":null,"ref":"ecron.html#t:end_at/0"},{"type":"type","title":"ecron.mfargs/0","doc":null,"ref":"ecron.html#t:mfargs/0"},{"type":"type","title":"ecron.name/0","doc":null,"ref":"ecron.html#t:name/0"},{"type":"type","title":"ecron.option/0","doc":null,"ref":"ecron.html#t:option/0"},{"type":"type","title":"ecron.options/0","doc":null,"ref":"ecron.html#t:options/0"},{"type":"type","title":"ecron.parse_error/0","doc":null,"ref":"ecron.html#t:parse_error/0"},{"type":"type","title":"ecron.register/0","doc":null,"ref":"ecron.html#t:register/0"},{"type":"type","title":"ecron.rfc3339_string/0","doc":null,"ref":"ecron.html#t:rfc3339_string/0"},{"type":"type","title":"ecron.start_at/0","doc":null,"ref":"ecron.html#t:start_at/0"},{"type":"type","title":"ecron.statistic/0","doc":null,"ref":"ecron.html#t:statistic/0"},{"type":"type","title":"ecron.status/0","doc":null,"ref":"ecron.html#t:status/0"},{"type":"extras","title":"Overview","doc":"# ecron [![GitHub Actions](https://github.com/zhongwencool/ecron/actions/workflows/ci.yml/badge.svg)](https://github.com/zhongwencool/ecron) [![CodeCov](https://codecov.io/gh/zhongwencool/ecron/branch/master/graph/badge.svg?token=FI9WAQ6UG5)](https://codecov.io/gh/zhongwencool/ecron) [![Hex](https://img.shields.io/hexpm/v/ecron.svg?style=flat)](https://hex.pm/packages/ecron) [![Tag](https://img.shields.io/github/tag/zhongwencool/ecron.svg)](https://img.shields.io/github/tag/zhongwencool/ecron.svg) [![License](https://img.shields.io/hexpm/l/ecron.svg)](https://img.shields.io/hexpm/l/ecron.svg) [![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ecron/)\r\n\r\nA lightweight and efficient cron-like job scheduling library for Erlang.\r\n\r\n# Overview\r\nEcron is designed to manage scheduled jobs within a single gen_server process, similar to the standard library's [stdlib's timer](http://erlang.org/doc/man/timer.html). It uses an ordered_set ETS table to organize jobs by the next run time, ensuring efficient execution. Unlike traditional cron, Ecoron does not poll the system every second, which reduces message overhead and process usage.","ref":"readme.html"},{"type":"extras","title":"Key Features - Overview","doc":"- Supports both cron-like and interval-based scheduling.\r\n- Well-tested with [PropTest](https://github.com/proper-testing/proper) [![codecov](https://codecov.io/gh/zhongwencool/ecron/branch/master/graph/badge.svg?token=FI9WAQ6UG5)](https://codecov.io/gh/zhongwencool/ecron).\r\n- Utilizes gen_server timeout mechanism for precise timing.\r\n- Efficient process management, avoiding high memory usage.","ref":"readme.html#key-features"},{"type":"extras","title":"Installation - Overview","doc":"<!-- tabs-open -->","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Overview","doc":"```erlang\r\n  %% rebar.config\r\n  {deps, [ecron]}\r\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Overview","doc":"```elixir\r\n  # mix.exs\r\n  def deps do\r\n    [{:ecron, \"~> 1.0.1\"}]\r\n  end\r\n```\r\n\r\n<!-- tabs-close -->","ref":"readme.html#elixir"},{"type":"extras","title":"Basic Usage - Overview","doc":"Configure Ecoron in your sys.config file with timezone and job specifications:\r\n\r\n```erlang\r\n%% sys.config\r\n[\r\n   {ecron, [      \r\n      {time_zone, local}, %% local or utc\r\n      {local_jobs, [\r\n         %% {JobName, CrontabSpec, {M, F, A}}\r\n         %% {JobName, CrontabSpec, {M, F, A}, StartDateTime, EndDateTime}\r\n         %% CrontabSpec\r\n            %%  1. \"Minute Hour DayOfMonth Month DayOfWeek\"\r\n            %%  2. \"Second Minute Hour DayOfMonth Month DayOfWeek\"\r\n            %%  3. @yearly | @annually | @monthly | @weekly | @daily | @midnight | @hourly\r\n            %%  4. @every 1h2m3s\r\n                  \r\n         {crontab_job, \"*/15 * * * *\", {io, format, [\"Runs on 0, 15, 30, 45 minutes~n\"]}},\r\n         {extend_crontab_job, \"0 0 1-6/2,18 * * *\", {io, format, [\"Runs on 1,3,6,18 o'clock:~n\"]}},\r\n         {alphabet_job, \"@hourly\", {io, format, [\"Runs every(0-23) o'clock~n\"]}},    \r\n         {fixed_interval_job, \"@every 30m\", {io, format, [\"Runs every 30 minutes\"]}},\r\n         %% Runs every 15 minutes between {8,20,0} and {23, 59, 59}.\r\n         %% {limit_time_job, \"*/15 * * * *\", {io, format, [\"Runs 0, 15, 30, 45 minutes after 8:20am~n\"]}, {8,20,0}, unlimited}\r\n         %% parallel job         \r\n         {no_singleton_job, \"@minutely\", {timer, sleep, [61000]}, unlimited, unlimited, [{singleton, false}]}            \r\n     ]},\r\n     {global_jobs, []}, %% Global Spec has the same format as local_jobs.\r\n     {global_quorum_size, 1} %%  Minimum number of nodes which run ecron. Global_jobs only run on majority cluster when it > ClusterNode/2.\r\n    }\r\n].\r\n```\r\n\r\n* Default `time_zone` is `local`, the current datetime is [calendar:local_time()](http://erlang.org/doc/man/calendar.html#local_time-0).\r\n* The current datetime is [calendar:universal_time()](http://erlang.org/doc/man/calendar.html#universal_time-0) when `{time_zone, utc}`.\r\n* The job will be auto remove at `EndDateTime`, the default value of `EndDateTime` is `unlimited`. \r\n* Default job is singleton, Each task cannot be executed concurrently. \r\n* If the system clock suddenly alter a lot(such as sleep your laptop for two hours or modify system time manually),\r\n  it will skip the tasks which are supposed be running during the sudden lapse of time,\r\n  then recalculate the next running time by the latest system time.\r\n  You can also reload task manually by `ecron:reload().` when the system time is manually modified.\r\n* Global jobs depend on [global](http://erlang.org/doc/man/global.html), only allowed to be added statically, [check this for more detail](https://github.com/zhongwencool/ecron/blob/master/doc/global.md).","ref":"readme.html#basic-usage"},{"type":"extras","title":"Supervisor Tree Usage - Overview","doc":"Ecron can be integrated into your application's supervision tree for better control over its lifecycle:\r\n\r\n```erlang\r\n%%config/sys.config\r\n[{your_app, [{crontab_jobs, [\r\n   {crontab_job, \"*/15 * * * *\", {stateless_cron, inspect, [\"Runs on 0, 15, 30, 45 minutes\"]}}\r\n  ]}\r\n].\r\n\r\n%% src/your_app_sup.erl\r\n-module(your_app_top_sup).\r\n-behaviour(supervisor).\r\n-export([init/1]).\r\n\r\ninit(_Args) ->\r\n    Jobs = application:get_env(your_app, crontab_jobs, []),\r\n    SupFlags = #{\r\n        strategy => one_for_one,\r\n        intensity => 100,\r\n        period => 30\r\n    },\r\n    Name = 'uniqueName',\r\n    CronSpec = #{\r\n        id => Name,\r\n        start => {ecron, start_link, [Name, Jobs]},\r\n        restart => permanent,\r\n        shutdown => 1000,\r\n        type => worker\r\n    },\r\n    {ok, {SupFlags, [CronSpec]}}.\r\n\r\n```","ref":"readme.html#supervisor-tree-usage"},{"type":"extras","title":"Advanced Usage - Overview","doc":"Ecron allows for advanced scheduling and manipulation of cron jobs:\r\n\r\n```erlang\r\n%% Same as: Spec = \"0 * 0-5,18 * * 0-5\", \r\nSpec = #{second => [0], \r\n       minute => '*',   \r\n       hour => [{0,5}, 18], %% same as [0,1,2,3,4,5,18]\r\n       month => '*',\r\n       day_of_month => '*',\r\n       day_of_week => [{0,5}]},\r\nCronMFA = {io, format, [\"Runs on 0-5,18 o'clock between Sunday and Firday.~n\"]},\r\n%% with name crontab  \r\n{ok, _} = ecron:add(crontabUniqueName, Spec, CronMFA),\r\n%% or\r\n{ok, _} = ecron:add(crontabUniqueName, \"0 * 0-5,18 * * 0-5\", CronMFA),   \r\nok = ecron:delete(crontabuniqueName),\r\n%% crontab with startTime and endTime\r\nStartDateTime = {{2019,9,19},{0,0,0}},\r\nEndDateTime = {{2020,9,19},{0,0,0}},\r\n{ok, _} = ecron:add(crontabUniqueName, Spec, CronMFA, StartDateTime, EndDateTime),\r\n%% crontab without name\r\n{ok, JobName} = ecron:add(Spec, CronMFA, StartDateTime, EndDateTime), \r\nok = ecron:delete(crontabuniqueName),\r\n%% Runs every 120 second (fixed interval)\r\nEveryMFA = {io, format, [\"Runs every 120 second.~n\"]},\r\n{ok, _} = ecron:add(everyUniqueName, 120, EveryMFA),\r\n```\r\n\r\nYou can find a collection of general practices in [Full Erlang Examples](https://github.com/zhongwencool/ecron/blob/master/examples/titan_erlang) and [Full Elixir Examples](https://github.com/zhongwencool/ecron/blob/master/examples/titan_elixir).","ref":"readme.html#advanced-usage"},{"type":"extras","title":"Debug Support - Overview","doc":"Ecron provides functions to assist with debugging:\r\n\r\n````erlang\r\n1> ecron:deactivate(CrontabName).\r\nok\r\n\r\n2> ecron:activate(CrontabName).\r\nok\r\n\r\n3> ecron:statistic(CrontabName).\r\n{ok,\r\n  #{crontab =>\r\n      #{day_of_month => '*',\r\n       day_of_week => [{1,5}],hour => [1,13],\r\n       minute => [0],month => '*',second => [0]},\r\n       start_time => unlimited,end_time => unlimited,\r\n       failed => 0,mfa => {io,format,[\"ddd\"]},\r\n       name => test,status => activate,type => cron,\r\n       ok => 1,results => [ok],run_microsecond => [12],       \r\n       opts => [{singleton,true}], node => 'test@127.0.0.1',\r\n       next =>\r\n          [\"2019-09-27T01:00:00+08:00\",\"2019-09-27T13:00:00+08:00\",\r\n           \"2019-09-30T01:00:00+08:00\",\"2019-09-30T13:00:00+08:00\",\r\n           \"2019-10-01T01:00:00+08:00\",\"2019-10-01T13:00:00+08:00\",\r\n           \"2019-10-02T01:00:00+08:00\",\"2019-10-02T13:00:00+08:00\",\r\n           [...]|...]      \r\n      }\r\n}\r\n\r\n4> ecron:parse_spec(\"0 0 1,13 * * 1-5\", 5).\r\n{ok,\r\n#{crontab =>\r\n      #{day_of_month => '*',\r\n        day_of_week => [{1,5}],\r\n        hour => [1,13],\r\n        minute => [0],\r\n        month => '*',\r\n        second => [0]},\r\n  next =>\r\n      [\"2019-09-16T13:00:00+08:00\",\"2019-09-17T01:00:00+08:00\",\r\n       \"2019-09-17T13:00:00+08:00\",\"2019-09-18T01:00:00+08:00\",\r\n       \"2019-09-18T13:00:00+08:00\"],\r\n  type => cron}\r\n}\r\n````","ref":"readme.html#debug-support"},{"type":"extras","title":"Implementation - Overview","doc":"Ecron uses an efficient approach to manage job execution times and intervals:\r\n\r\n1. The top supervisor `ecron_sup` starts firstly.\r\n2. then `ecron_sup` starts a child `ecron`(gen_server worker).\r\n3. `ecron` will look for configuration `{local_jobs, Jobs}` at initialization.\r\n4. For each crontab job found, determine the next time in the future that each command must run.\r\n5. Place those commands on the ordered_set ets with their `{NextCorrespondingTime, Name}` to run as key.\r\n6. Enter `ecron`'s main loop:\r\n    * Examine the task entry at the head of the ets, compute how far in the future it must run.\r\n    * Sleep for that period of time by gen_server timeout feature.\r\n    * On awakening and after verifying the correct time, execute the task at the head of the ets (spawn in background).\r\n    * Delete old key in ets.\r\n    * Determine the next time in the future to run this command and place it back on the ets at that time value.\r\n    \r\nAdditionally, you can use `ecron:statistic(Name)` to see the job's latest 16 results and execute times.\r\n```\r\n    ecron_sup------->ecron\r\n                      |\r\n                   |------| ets:new(timer, [ordered_set])\r\n                   | init | ets:insert(timer, [{{NextTriggeredTime,Name}...])\r\n                   |------|\r\n             |------->|\r\n             |     |------| {NextTriggeredTime,Name} = OldKey = ets:first(timer)\r\n             |     |      | sleep(NextTriggeredTime - current_time())\r\n             |     | loop | spawn a process to execute MFA\r\n             |     |      | ets:delete(timer, OldKey)\r\n             |     |------| ets:insert(timer, {{NewTriggeredTime,Name}...])\r\n             |<-------|\r\n```\r\n\r\n[Check this for global_jobs workflow](global.html#Implementation).","ref":"readme.html#implementation"},{"type":"extras","title":"CRON Expression Guide - Overview","doc":"","ref":"readme.html#cron-expression-guide"},{"type":"extras","title":"Basic Format - Overview","doc":"A cron expression consists of 5-6 fields representing time units:\r\n\r\n```\r\n# ┌────────────── second (optional)\r\n# │ ┌──────────── minute\r\n# │ │ ┌────────── hour\r\n# │ │ │ ┌──────── day of month\r\n# │ │ │ │ ┌────── month\r\n# │ │ │ │ │ ┌──── day of week\r\n# │ │ │ │ │ │\r\n# │ │ │ │ │ │\r\n# 0 * * * * *\r\n```","ref":"readme.html#basic-format"},{"type":"extras","title":"Field Values - Overview","doc":"Field | Required | Values | Special Characters\r\nSecond | No | 0-59 | `* / , -`\r\nMinute | Yes | 0-59 | `* / , -`\r\nHour | Yes | 0-23 | `* / , -`\r\nDay of Month | Yes | 1-31 | `* / , -`\r\nMonth | Yes | 1-12 or JAN-DEC | `* / , -`\r\nDay of Week | Yes | 0-6 or SUN-SAT | `* / , -`\r\n\r\n> **Note**: Month and Day-of-week values are case-insensitive.","ref":"readme.html#field-values"},{"type":"extras","title":"Special Characters - Overview","doc":"- `*` - Any value\r\n- `/` - Step values (e.g., `*/15` - every 15 units)\r\n- `,` - Value list (e.g., `1,3,5`)\r\n- `-` - Range (e.g., `1-5`)","ref":"readme.html#special-characters"},{"type":"extras","title":"Predefined Schedules - Overview","doc":"Expression | Description | Equivalent\r\n`@yearly` | Once a year (midnight, Jan 1) | `0 0 0 1 1 *`\r\n`@monthly` | Once a month (midnight, first day) | `0 0 0 1 * *`\r\n`@weekly` | Once a week (midnight, Sunday) | `0 0 0 * * 0`\r\n`@daily` | Once a day (midnight) | `0 0 0 * * *`\r\n`@hourly` | Once an hour | `0 0 * * * *`\r\n`@minutely` | Once a minute | `0 * * * * *`","ref":"readme.html#predefined-schedules"},{"type":"extras","title":"Fixed Intervals - Overview","doc":"For simpler scheduling needs, use `@every` with a duration:\r\n\r\n```erlang\r\n% Run every 30 minutes\r\n\"@every 30m\"\r\n\r\n% Run every 1 hour and 30 minutes\r\n\"@every 1h30m\"\r\n```\r\n\r\nDuration units: `d`(days), `h`(hours), `m`(minutes), `s`(seconds)","ref":"readme.html#fixed-intervals"},{"type":"extras","title":"Error Handling - Overview","doc":"- Failed jobs don't affect other jobs\r\n- Execution results and timing are stored (last 16 runs)\r\n- Jobs can be configured as singleton or parallel\r\n- System time changes are handled gracefully","ref":"readme.html#error-handling"},{"type":"extras","title":"Best Practices - Overview","doc":"1. **Job Names**\r\n   - Use descriptive, unique names\r\n   - Consider adding prefixes for different job types\r\n\r\n2. **Time Windows**\r\n   - Use start/end times for temporary jobs\r\n   - Consider time zone implications\r\n\r\n3. **Error Handling**\r\n   - Implement proper error handling in job functions\r\n   - Monitor job execution through telemetry\r\n\r\n4. **Resource Management**\r\n   - Group related jobs under same supervisor\r\n   - Use `singleton: false` only when needed\r\n\r\n5. **Testing**\r\n   - Validate cron expressions before deployment\r\n   - Test jobs with different time scenarios","ref":"readme.html#best-practices"},{"type":"extras","title":"Test - Overview","doc":"This command will run property-based tests, common tests, and generate a coverage report with verbose output.\r\n\r\n```shell\r\n  $ rebar3 do proper -c, ct -c, cover -v\r\n```","ref":"readme.html#test"},{"type":"extras","title":"Telemetry","doc":"Ecron uses [Telemetry](https://github.com/beam-telemetry/telemetry) for instrumentation and for having an extensible way of doing logging. \n Telemetry is a metrics and instrumentation library for Erlang and Elixir applications \n that is based on publishing events through a common interface and attaching handlers to handle those events. \n For more information about the library itself, see its [README](https://github.com/beam-telemetry/telemetry).","ref":"telemetry.html"},{"type":"extras","title":"Writing your own handler - Telemetry","doc":"If you want control on how ecron events are logged or on what level they're logged at, \nyou can use your own event handler. For example, you can create a module to handle these events:\n\n```erlang\n-module(my_ecron_telemetry_logger).\n-include_lib(\"kernel/include/logger.hrl\").\n-define(Events, [[ecron, success], [ecron, failure], [ecron, activate], \n                 [ecron, deactivate], [ecron, delete], \n                 [ecron, global, up], [ecron, global, down]]).\n%% API\n-export([attach/0, detach/0]).\n-define(TELEMETRY_HANDLE, ecron_telemetry_metrics).\nattach() ->\n    telemetry:attach_many(?TELEMETRY_HANDLE, ?Events, fun handle_event/4, undefined).\n\ndetach() -> telemetry:detach(?TELEMETRY_HANDLE).\n\nhandle_event([ecron, activate], #{action_ms := Time}, #{name := Name, mfa := MFA}, _Config) ->\n    ?LOG_INFO(\"EcronJob(~p)-~p activated at ~p .\", [Name, MFA, Time]);\nhandle_event([ecron, deactivate], #{action_ms := Time}, #{name := Name}, _Config) ->\n    ?LOG_INFO(\"EcronJob(~p) deactivated at ~p .\", [Name, Time]);\nhandle_event([ecron, delete], #{action_ms := Time}, #{name := Name}, _Config) ->\n    ?LOG_INFO(\"EcronJob(~p) deleted at ~p .\", [Name, Time]);\nhandle_event([ecron, success], #{run_microsecond := Ms, run_result := Res},\n    #{name := Name, mfa := {M, F, A}}, _Config) ->\n    ?LOG_INFO(\"EcronJob(~p) completed in ~p microsecond.~p=apply(~p,~p,~p)\", [Name, Ms, Res, M, F, A]);\nhandle_event([ecron, success], #{run_microsecond := Ms, run_result := Res},\n    #{name := Name, mfa := {F, A}}, _Config) ->\n    ?LOG_INFO(\"EcronJob(~p) completed in ~p microsecond.~p=apply(~p,~p)\", [Name, Ms, Res, F, A]);\nhandle_event([ecron, failure], #{run_microsecond := Ms, run_result := {Error, Reason, Stack}},\n    #{name := Name, mfa := MFA}, _Config) ->\n    ?LOG_ERROR(\"EcronJob(~p)-~p CRASH in ~p microsecond. {Error, Reason}: {~p, ~p}. Stack:~p\",\n        [Name, MFA, Ms, Error, Reason, Stack]);\nhandle_event([ecron, global, up], #{action_ms := Time, quorum_size := QuorumSize,\n    good_nodes := GoodNodes, bad_nodes := BadNodes}, #{self := Node}, _Config) ->\n    ?LOG_INFO(\"Ecron Global UP on ~p at ~p quorum_size is ~p good_nodes is ~p bad_nodes is ~p ~n.\",\n        [Node, Time, QuorumSize, GoodNodes, BadNodes]);\nhandle_event([ecron, global, down], #{action_ms := Time, quorum_size := QuorumSize,\n    good_nodes := GoodNodes, bad_nodes := BadNodes}, #{self := Node}, _Config) ->\n    ?LOG_INFO(\"Ecron Global DOWN on ~p at ~p quorum_size is ~p good_nodes is ~p bad_nodes is ~p ~n.\",\n        [Node, Time, QuorumSize, GoodNodes, BadNodes]).\n``` \n\nOnce you have a module like this, you can attach it when your application starts:\n```erlang\n-module(my_app).\n-behaviour(application).\n\n-export([start/2, stop/1]).\n\nstart(_StartType, _StartArgs) ->\n    my_ecron_telemetry_logger:attach(),\n    my_sup:start_link().\n\nstop(_State) ->\n    my_ecron_telemetry_logger:detach(),\n    ok.\n```\n\nMore detail can be seen in [erlang example](https://github.com/zhongwencool/ecron/blob/master/examples/titan_erlang/apps/titan/src/titan_ecron_logger.erl) and [elixir example](https://github.com/zhongwencool/ecron/blob/master/examples/titan_elixir/apps/titan/lib/titan_ecron_logger.ex).","ref":"telemetry.html#writing-your-own-handler"},{"type":"extras","title":"Metrics - Telemetry","doc":"|     Event   | measurements                             | metadata                    | Describe                                            |\n| ----------- | ---------------------------------------- | --------------------------- | --------------------------------------------------- |\n| success     |#{run_microsecond=>Cost,run_result=>Res}  | #{name=>Name,mfa=>MFA}      | Execute MFA successfully                            |\n| failure     |#{run_microsecond=>Cost,run_result=>Res}  | #{name=>Name,mfa=>MFA}      | MFA crashed(unsuccessfully)                         |\n| activate    |#{action_ms=>Now}                         | #{name=>Name,mfa=>MFA}      | ecron:add or ecron:activate                         |\n| deactivate  |#{action_ms=>Now}                         | #{name=>Name}               | ecron:deactivate                                    |\n| delete      |#{action_ms=>Now}                         | #{name=>Name}               | ecron:delete or CurrentTime =:= job's EndDateTime   |\n| global,up   |GlobalMeasurements                        | #{self=>node()}             | Global manager process is up                        |\n| global,down |GlobalMeasurements                        | #{self=>node()}             | Global manager process is down                      |\n\n\n- `Now = erlang:system_time(millisecond)`.\n- `GlobalMeasurements = #{action_ms=>Now,quorum_size=>integer(),good_nodes=>[node()],bad_nodes=>[node()]}`.","ref":"telemetry.html#metrics"},{"type":"extras","title":"Cluster Task","doc":"","ref":"global.html"},{"type":"extras","title":"Precondition - Cluster Task","doc":"1. Fully Connected Cluster\n \n   Because it depends on `global`'s name registration service. \n   The name server must maintains a fully connected network. \n\n   For example, if node N1 connects to node N2 (which is already connected to N3), \n   the global name servers on the nodes N1 and N3 ensure that also N1 and N3 are connected. \n   In other words, command-line flag `-connect_all false` can not be used.\n\n2. Same Global Configuration\n \n   All node's `global_quorum_size` and `global_jobs` must keep the same value. \n   This ensures that the global task manager can transfer between nodes when the network splits.","ref":"global.html#precondition"},{"type":"extras","title":"Configuration - Cluster Task","doc":"1. `global_jobs`\n\n    the same format as `local_jobs`, default is `[]`. \n    This means only run local jobs without running global task manager and monitor processes.\n\n2. `global_quorum_size`\n \n   ecron application live on at least `global_quorum_size` nodes in the same cluster, can be regarded as a healthy cluster. \n\n   Global task manager only running on a healthy cluster.\n\n   If you want to guarantee always no more than **one** global task manager even when the cluster has network split,\n   you should set it to **\"half plus one\"**. For example:\n\n   Run on majority:\n   1. `ABC` 3 nodes in one cluster.\n   2. `global_quorum_size=2`.\n   3. (`ABC`) cluster split into 2 part(`AB`  =|=  `C`).\n   4. the global task manager would run on `AB` cluster(`AB` is the healthy cluster now).\n   5. `C` node only running local jobs without global jobs.\n\n   Run on majority \n   1. `ABC` 3 nodes in one cluster.\n   2. `global_quorum_size=2`.\n   3. (`ABC`) cluster split into 3 part(`A` =|= `B`  =|=  `C`).\n   4. every node only running local jobs without global jobs(all nodes is unhealthy).\n\n   Run on every node if brain split.\n   1. `ABC` nodes in one cluster.    \n   2. `global_quorum_size=1`.\n   3. (`ABC`) cluster split into 3 part(`A` =|= `B`  =|=  `C`).\n   4. the global task manager would run on every nodes(we have three healthy cluster now).\n   5. But the global task manager only running one in the same cluster.","ref":"global.html#configuration"},{"type":"extras","title":"Implementation - Cluster Task","doc":"1. The top supervisor `ecron_sup` start at first.\n2. Nothing will happen if the `global_jobs` is empty.\n3. `ecron_sup` would start_link `ecron_monitor` worker (gen_server) if `global_jobs` is not empty.\n4. `ecron_monitor` subscribes node's up/down messages by [net_kernel:monitor_nodes(true)](http://erlang.org/doc/man/net_kernel.html#monitor_nodes-1), when it initializes.\n5. Enter `ecron_monitor` main loop:\n    * Checking if there is enough `ecron` process in the cluster(`global_quorum_size`).\n    * Trying to terminate global_job manager process when cluster's `ecron` number less than `global_quorum_size`.\n    * Otherwise, trying to start a global_job manager process, This gen_server register by [global:register_name/2](http://erlang.org/doc/man/global.html#register_name-2).\n    * All the nodes are rushing to register this global jobs manager process, only one node will success, other node's `ecron_monitor` would link this process if the process already exists.\n    * The `ecron_monitor` should receive notification, when node down/up or the global_job manager has terminated.\n    * Goto step 5 again, When notified.\n\n```\n     NodeA             NodeB             NodeC\n   supervisor        supervisor        supervisor\n       |                |     |            |\n    monitor          monitor  |          monitor\n         \\              |     |            /\n          \\           [link]  |           /\n           \\            |     |          /\n           [link]-----GlobalJob-----[link]\n``` \nNodeB has won the race and spawn global manager process, other node's `ecron_monitor` only link to this manager.","ref":"global.html#implementation"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"1.0.2 - Changelog","doc":"- Use ex_doc to update documentation.","ref":"changelog.html#1-0-2"},{"type":"extras","title":"1.0.1 - Changelog","doc":"- Fix concurrent cron job execution timing issue.","ref":"changelog.html#1-0-1"},{"type":"extras","title":"1.0.0 - Changelog","doc":"Nothing changed, just update version from 0.6.1 to 1.0.0.","ref":"changelog.html#1-0-0"},{"type":"extras","title":"0.6.1 - Changelog","doc":"- fix some spec warning.\r\n- upgrade telemetry to 1.1.0","ref":"changelog.html#0-6-1"},{"type":"extras","title":"0.5.2 - Changelog","doc":"- redefine `[ecron global up/down]` telemetry event.","ref":"changelog.html#0-5-2"},{"type":"extras","title":"0.5.1 - Changelog","doc":"- Replace `cluster_quorum_size` by `global_quorum_size`.\r\n- Check if job's name is duplicate.","ref":"changelog.html#0-5-1"},{"type":"extras","title":"0.5.0 - Changelog","doc":"- Support global_jobs by `global`.\r\n- Add global/up/down telemetry metrics.","ref":"changelog.html#0-5-0"},{"type":"extras","title":"0.4.0 - Changelog","doc":"- Add `ecron:reload/0`.\r\n- Expose telemetry metrics.","ref":"changelog.html#0-4-0"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright 2019-2025, zhongwencool  .\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}